# ChunkCodecLibZstd

## Warning: ChunkCodecLibZstd is currently a WIP and its API may drastically change at any time.

This package implements the ChunkCodec interface for the following encoders and decoders
using the zstd C library <www.zstd.net>

1. `ZstdCodec`, `ZstdEncodeOptions`, `ZstdDecodeOptions`

## Example

```julia-repl
julia> using ChunkCodecLibZstd

julia> data = [0x00, 0x01, 0x02, 0x03];

julia> compressed_data = encode(ZstdEncodeOptions(;compressionLevel=3), data);

julia> decompressed_data = decode(ZstdCodec(), compressed_data; max_size=length(data), size_hint=length(data));

julia> data == decompressed_data
true
```

The low level interface is defined in the `ChunkCodecCore` package.

module ChunkCodecLibZstd

using Zstd_jll: libzstd

using ChunkCodecCore:
    Codec,
    EncodeOptions,
    DecodeOptions,
    check_contiguous,
    check_in_range,
    DecodingError,
    MaybeSize,
    NOT_SIZE
import ChunkCodecCore:
    can_concatenate,
    try_decode!,
    try_encode!,
    encode_bound,
    is_thread_safe,
    try_find_decoded_size,
    decoded_size_range,
    decode_options

export ZstdCodec,
    ZstdEncodeOptions,
    ZstdDecodeOptions,
    ZstdDecodingError


if VERSION >= v"1.11.0-DEV.469"
    eval(Meta.parse("""
        public
            ZSTD_minCLevel,
            ZSTD_maxCLevel,
            ZSTD_defaultCLevel,
            ZSTD_versionNumber,
            ZSTD_isError,
            ZSTD_bounds,
            ZSTD_cParam_getBounds,
            ZSTD_dParam_getBounds
    """))
end

# reexport ChunkCodecCore
using ChunkCodecCore: ChunkCodecCore, encode, decode
export ChunkCodecCore, encode, decode


include("libzstd.jl")

"""
    struct ZstdCodec <: Codec
    ZstdCodec()

Zstandard compression using libzstd: www.zstd.net

Zstandard's format is documented in [RFC8878](https://datatracker.ietf.org/doc/html/rfc8878)

Like libzstd's simple API, encode compresses data as a single frame with saved
decompressed size. Decoding will succeed even if the decompressed size is unknown.
Also like libzstd's simple API, decoding accepts concatenated frames 
and will error if there is invalid data appended.

See also [`ZstdEncodeOptions`](@ref) and [`ZstdDecodeOptions`](@ref)
"""
struct ZstdCodec <: Codec
end
decode_options(::ZstdCodec) = ZstdDecodeOptions()

include("encode.jl")
include("decode.jl")

end # module ChunkCodecLibZstd

# Constants and c wrapper functions ported to Julia from zstd.h and zstd_errors.h
# https://github.com/facebook/zstd/blob/v1.5.6/lib/zstd.h
# https://github.com/facebook/zstd/blob/v1.5.6/lib/zstd_errors.h

"""
    ZSTD_minCLevel()::Int32

Return the minimum negative compression level allowed.
"""
function ZSTD_minCLevel()::Int32
    ccall((:ZSTD_minCLevel, libzstd), Cint, ())
end

"""
    ZSTD_maxCLevel()::Int32

Return the maximum compression level available.
"""
function ZSTD_maxCLevel()::Int32
    ccall((:ZSTD_maxCLevel, libzstd), Cint, ())
end

"""
    ZSTD_defaultCLevel()::Int32

Return the default compression level.
"""
function ZSTD_defaultCLevel()::Int32
    ccall((:ZSTD_defaultCLevel, libzstd), Cint, ())
end

"""
    ZSTD_versionNumber()::VersionNumber

Return the zstd runtime library version.
"""
function ZSTD_versionNumber()::VersionNumber
    v = ccall((:ZSTD_versionNumber, libzstd), Cuint, ())
    major = v ÷ 100_00
    minor = (v ÷ 100) % 100
    patch = v % 100
    VersionNumber(major, minor, patch)
end

"""
    ZSTD_isError(ret::Csize_t)::Bool

Return true if return `ret` is an error.
"""
function ZSTD_isError(ret::Csize_t)::Bool
    !iszero(ccall((:ZSTD_isError, libzstd), Cuint, (Csize_t,), ret))
end

"""
    struct ZSTD_bounds

Has the following fields:
- `error::Csize_t`
- `lowerBound::Cint`
- `upperBound::Cint`
"""
struct ZSTD_bounds
    error::Csize_t
    lowerBound::Cint
    upperBound::Cint
end

"""
    ZSTD_cParam_getBounds(cParam::Int32)::ZSTD_bounds

All parameters must belong to an interval with lower and upper bounds,
otherwise they will either trigger an error or be automatically clamped.
Return : a structure, [`ZSTD_bounds`](@ref), which contains
- an error status field, which must be tested using [`ZSTD_isError`](@ref)
- lower and upper bounds, both inclusive
"""
function ZSTD_cParam_getBounds(cParam::Int32)
    ccall((:ZSTD_cParam_getBounds, libzstd), ZSTD_bounds, (Cint,), cParam)
end

"""
    ZSTD_dParam_getBounds(dParam::Int32)::ZSTD_bounds

All parameters must belong to an interval with lower and upper bounds,
otherwise they will either trigger an error or be automatically clamped.
Return : a structure, [`ZSTD_bounds`](@ref), which contains
- an error status field, which must be tested using [`ZSTD_isError`](@ref)
- lower and upper bounds, both inclusive
"""
function ZSTD_dParam_getBounds(dParam::Int32)
    ccall((:ZSTD_dParam_getBounds, libzstd), ZSTD_bounds, (Cint,), dParam)
end


@assert Culonglong == UInt64
const ZSTD_CONTENTSIZE_UNKNOWN = -1%UInt64
const ZSTD_CONTENTSIZE_ERROR   = -2%UInt64

# convert a result into an error code, which can be compared to error enum list
function ZSTD_getErrorCode(ret::Csize_t)::Cint
    ccall((:ZSTD_getErrorCode, libzstd), Cint, (Csize_t,), ret)
end
# provides readable string from a function result
function ZSTD_getErrorName(ret::Csize_t)::String
    unsafe_string(ccall((:ZSTD_getErrorName, libzstd), Ptr{Cchar}, (Csize_t,), ret))
end

@enum ZSTD_ErrorCode::Cint begin
    ZSTD_error_no_error = 0
    ZSTD_error_GENERIC = 1
    ZSTD_error_prefix_unknown = 10
    ZSTD_error_version_unsupported = 12
    ZSTD_error_frameParameter_unsupported = 14
    ZSTD_error_frameParameter_windowTooLarge = 16
    ZSTD_error_corruption_detected = 20
    ZSTD_error_checksum_wrong = 22
    ZSTD_error_literals_headerWrong = 24
    ZSTD_error_dictionary_corrupted = 30
    ZSTD_error_dictionary_wrong = 32
    ZSTD_error_dictionaryCreation_failed = 34
    ZSTD_error_parameter_unsupported = 40
    ZSTD_error_parameter_combination_unsupported = 41
    ZSTD_error_parameter_outOfBound = 42
    ZSTD_error_tableLog_tooLarge = 44
    ZSTD_error_maxSymbolValue_tooLarge = 46
    ZSTD_error_maxSymbolValue_tooSmall = 48
    ZSTD_error_stabilityCondition_notRespected = 50
    ZSTD_error_stage_wrong = 60
    ZSTD_error_init_missing = 62
    ZSTD_error_memory_allocation = 64
    ZSTD_error_workSpace_tooSmall = 66
    ZSTD_error_dstSize_tooSmall = 70
    ZSTD_error_srcSize_wrong = 72
    ZSTD_error_dstBuffer_null = 74
    ZSTD_error_noForwardProgress_destFull = 80
    ZSTD_error_noForwardProgress_inputEmpty = 82
    # following error codes are __NOT STABLE__, they can be removed or changed in future versions
    # ZSTD_error_frameIndex_tooLarge = 100
    # ZSTD_error_seekableIO = 102
    # ZSTD_error_dstBuffer_wrong = 104
    # ZSTD_error_srcBuffer_wrong = 105
    # ZSTD_error_sequenceProducer_failed = 106
    # ZSTD_error_externalSequences_invalid = 107
    # ZSTD_error_maxCode = 120
end



# Just used to mark the type of pointers
mutable struct ZSTD_CCtx end
mutable struct ZSTD_DCtx end

# set parameter and throw error if it fails
# context must be initialized
function _set_parameter(cctx::Ptr{ZSTD_CCtx}, param::Cint, value::Cint)
    ret = ccall(
        (:ZSTD_CCtx_setParameter, libzstd), Csize_t,
        (Ptr{ZSTD_CCtx}, Cint, Cint),
        cctx, param, value,
    )
    if ZSTD_isError(ret)
        error("$(ZSTD_getErrorName(ret)): setting parameter $(param) to $(value)")
    end
    nothing
end
function _set_parameter(dctx::Ptr{ZSTD_DCtx}, param::Cint, value::Cint)
    ret = ccall(
        (:ZSTD_DCtx_setParameter, libzstd), Csize_t,
        (Ptr{ZSTD_CCtx}, Cint, Cint),
        dctx, param, value,
    )
    if ZSTD_isError(ret)
        error("$(ZSTD_getErrorName(ret)): setting parameter $(param) to $(value)")
    end
    nothing
end


# The following is the original license info from zstd.h and LICENSE file

#=
/*
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 * All rights reserved.
 *
 * This source code is licensed under both the BSD-style license (found in the
 * LICENSE file in the root directory of this source tree) and the GPLv2 (found
 * in the COPYING file in the root directory of this source tree).
 * You may select, at your option, one of the above-listed licenses.
 */
=#

#= contents of LICENSE
BSD License

For Zstandard software

Copyright (c) Meta Platforms, Inc. and affiliates. All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

 * Redistributions of source code must retain the above copyright notice, this
   list of conditions and the following disclaimer.

 * Redistributions in binary form must reproduce the above copyright notice,
   this list of conditions and the following disclaimer in the documentation
   and/or other materials provided with the distribution.

 * Neither the name Facebook, nor Meta, nor the names of its contributors may
   be used to endorse or promote products derived from this software without
   specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
=#

"""
    struct ZstdEncodeOptions <: EncodeOptions
    ZstdEncodeOptions(; kwargs...)

Zstandard compression using libzstd: www.zstd.net

Zstandard's format is documented in [RFC8878](https://datatracker.ietf.org/doc/html/rfc8878)

# Keyword Arguments

- `codec::ZstdCodec=ZstdCodec()`
- `compressionLevel::Integer=0`: Compression level, regular levels are 1-22.

  Levels ≥ 20 should be used with caution, as they require more memory.
  The library also offers negative compression levels,
  which extend the range of speed vs. ratio preferences.
  The lower the level, the faster the speed (at the cost of compression).
  0 is a special value for `ZSTD_defaultCLevel()`.
  The level will be clamped to the range `ZSTD_minCLevel()` to `ZSTD_maxCLevel()`.
- `checksum::Bool=false`: A 32-bits checksum of content is written at end of frame.
- `advanced_parameters::Vector{Pair{Int32, Int32}}=[]`: Pairs of `param => value`.

  Warning, some parameters can result in encodings that are incompatible with default decoders.
  Some parameters are experimental and may change in new versions of libzstd,
  so you may need to check [`ZSTD_versionNumber`](@ref) and [`ZSTD_cParam_getBounds`](@ref).
  See comments in zstd.h.
  Additional parameters are set with `ZSTD_CCtx_setParameter`. These parameters
  are set after the compression level, and checksum options are set, 
  so they can override those values.
  The vector must not be mutated after calling the constructor.
"""
struct ZstdEncodeOptions <: EncodeOptions
    codec::ZstdCodec
    compressionLevel::Int32
    checksum::Bool
    advanced_parameters::Vector{Pair{Int32, Int32}}
end
function ZstdEncodeOptions(;
        codec::ZstdCodec=ZstdCodec(),
        compressionLevel::Integer=0,
        checksum::Bool=false,
        advanced_parameters::Vector{Pair{Int32, Int32}}=Pair{Int32, Int32}[],
        kwargs...
    )
    _clamped_compression_level = clamp(compressionLevel, ZSTD_minCLevel(), ZSTD_maxCLevel())
    ZstdEncodeOptions(codec, _clamped_compression_level, checksum, advanced_parameters)
end

is_thread_safe(::ZstdEncodeOptions) = true

function decoded_size_range(::ZstdEncodeOptions)
    # prevent overflow of encode_bound
    # like ZSTD_MAX_INPUT_SIZE for Int64
    # From ChunkCodecTests.find_max_decoded_size(ZstdEncodeOptions())
    Int64(0):Int64(1):Int64(0x7F807F807F807F7F)
end

function encode_bound(::ZstdEncodeOptions, src_size::Int64)::Int64
    # ZSTD_COMPRESSBOUND ported to Julia
    # This also works when streaming
    # assuming no extra flushes
    # https://github.com/facebook/zstd/issues/3935
    # From zstd.h
    # #define ZSTD_COMPRESSBOUND(srcSize) (((size_t)(srcSize) >= ZSTD_MAX_INPUT_SIZE) ? 0 : (srcSize) + ((srcSize)>>8) + (((srcSize) < (128<<10)) ? (((128<<10) - (srcSize)) >> 11) /* margin, from 64 to 0 */ : 0)) 
    # /* this formula ensures that bound(A) + bound(B) <= bound(A+B) as long as A and B >= 128 KB */

    # Here we use Int64 instead of size_t
    margin = if src_size < (Int64(128)<<10)
        (((Int64(128)<<10) - src_size) >> 11)
    else 
        Int64(0)
    end::Int64
    clamp(widen(src_size) + widen(src_size>>8 + margin), Int64)
end

function try_encode!(e::ZstdEncodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    src_size::Int64 = length(src)
    dst_size::Int64 = length(dst)
    check_in_range(decoded_size_range(e); src_size)
    # create ZSTD_CCtx
    cctx = ccall((:ZSTD_createCCtx, libzstd), Ptr{ZSTD_CCtx}, ())
    if cctx == C_NULL
        throw(OutOfMemoryError())
    end
    try
        # set parameters
        ZSTD_c_compressionLevel = Cint(100)
        ZSTD_c_checksumFlag = Cint(201)
        _set_parameter(cctx, ZSTD_c_compressionLevel, Cint(e.compressionLevel))
        if e.checksum
            _set_parameter(cctx, ZSTD_c_checksumFlag, Cint(1))
        end
        for (param, value) in e.advanced_parameters
            _set_parameter(cctx, Cint(param), Cint(value))
        end
        # do compression
        ret = ccall((:ZSTD_compress2, libzstd), Csize_t,
            (Ptr{ZSTD_CCtx}, Ref{UInt8}, Csize_t, Ref{UInt8}, Csize_t,),
            cctx, dst, dst_size, src, src_size,
        )
        if ZSTD_isError(ret)
            err_code = ZSTD_getErrorCode(ret)
            if err_code == Integer(ZSTD_error_dstSize_tooSmall)
                return NOT_SIZE
            elseif err_code == Integer(ZSTD_error_memory_allocation)
                throw(OutOfMemoryError())
            else
                error("unexpected libzstd error code $(err_code) from ZSTD_compress2.")
            end
        else
            return Int64(ret)
        end
    finally
        # free ZSTD_CCtx
        ccall((:ZSTD_freeCCtx, libzstd), Csize_t, (Ptr{ZSTD_CCtx},), cctx)
    end
end

"""
    ZstdDecodingError(x)

Error for data that cannot be decoded.
"""
struct ZstdDecodingError <: DecodingError
    x::Union{Symbol, Csize_t}
end

function Base.showerror(io::IO, err::ZstdDecodingError)
    print(io, "ZstdDecodingError: ")
    if err.x isa Symbol
        print(io, err.x)
    else
        print(io, ZSTD_getErrorName(err.x))
    end
    nothing
end

"""
    struct ZstdDecodeOptions <: DecodeOptions
    ZstdDecodeOptions(; kwargs...)

Zstandard decompression using libzstd: www.zstd.net

Zstandard's format is documented in [RFC8878](https://datatracker.ietf.org/doc/html/rfc8878)

# Keyword Arguments

- `codec::ZstdCodec=ZstdCodec()`
- `advanced_parameters::Vector{Pair{Int32, Int32}}=[]`: Pairs of `param => value`.

  Warning, some parameters are experimental and may change in new versions of libzstd,
  so you may need to check [`ZSTD_versionNumber`](@ref) and [`ZSTD_dParam_getBounds`](@ref).
  See comments in zstd.h.
  Additional parameters are set with `ZSTD_DCtx_setParameter`.
  The vector must not be mutated after calling the constructor.
"""
struct ZstdDecodeOptions <: DecodeOptions
    codec::ZstdCodec
    advanced_parameters::Vector{Pair{Int32, Int32}}
end
function ZstdDecodeOptions(;
        codec::ZstdCodec=ZstdCodec(),
        advanced_parameters::Vector{Pair{Int32, Int32}}=Pair{Int32, Int32}[],
        kwargs...
    )
    ZstdDecodeOptions(codec, advanced_parameters)
end

is_thread_safe(::ZstdDecodeOptions) = true

can_concatenate(::ZstdDecodeOptions) = true

# find_decompressed_size is modified from CodecZstd.jl
# https://github.com/JuliaIO/CodecZstd.jl/blob/2f7d084b8b157d83ed85e9d15105f0a708038e45/src/libzstd.jl#L157C1-L215C4
# From mkitti's PR https://github.com/JuliaIO/CodecZstd.jl/pull/63
function try_find_decoded_size(::ZstdDecodeOptions, src::AbstractVector{UInt8})::Union{Nothing, Int64}
    check_contiguous(src)
    srcSize::Int64 = length(src)
    frameOffset::Int64 = 0
    decompressedSize::Int64 = 0
    while frameOffset < srcSize
        remainingSize = srcSize - frameOffset
        # Obtain the decompressed frame content size of the next frame, accumulate
        frameContentSize = ccall(
            (:ZSTD_getFrameContentSize, libzstd), Culonglong,
            (Ref{UInt8}, Csize_t),
            Ref(src, firstindex(src) + frameOffset), remainingSize,
        )
        if frameContentSize == ZSTD_CONTENTSIZE_UNKNOWN
            return nothing
        end
        if frameContentSize > typemax(Int64) # also handles ZSTD_CONTENTSIZE_ERROR
            throw(ZstdDecodingError(:decoded_size_error))
        end
        decompressedSize, overflow = Base.Checked.add_with_overflow(decompressedSize, frameContentSize%Int64)
        if overflow
            throw(ZstdDecodingError(:decoded_size_overflow))
        end
        # Advance the offset forward by the size of the compressed frame
        # this is required if there are more than on frame
        ret = ccall(
            (:ZSTD_findFrameCompressedSize, libzstd), Csize_t,
            (Ref{UInt8}, Csize_t),
            Ref(src, firstindex(src) + frameOffset), remainingSize,
        )
        if ZSTD_isError(ret)
            err_code = ZSTD_getErrorCode(ret)
            if err_code == Integer(ZSTD_error_memory_allocation)
                throw(OutOfMemoryError())
            else
                throw(ZstdDecodingError(ret))
            end
        end
        @assert ret ∈ 1:remainingSize
        frameOffset += Int64(ret)
    end
    @assert frameOffset == srcSize
    return decompressedSize
end

function try_decode!(d::ZstdDecodeOptions, dst::AbstractVector{UInt8}, src::AbstractVector{UInt8}; kwargs...)::MaybeSize
    check_contiguous(dst)
    check_contiguous(src)
    if isempty(src)
        throw(ZstdDecodingError(:src_empty))
    end
    # create ZSTD_DCtx
    dctx = ccall((:ZSTD_createDCtx, libzstd), Ptr{ZSTD_DCtx}, ())
    if dctx == C_NULL
        throw(OutOfMemoryError())
    end
    try
        # set parameters
        for (param, value) in d.advanced_parameters
            _set_parameter(dctx, Cint(param), Cint(value))
        end
        # do decompression
        ret = ccall((:ZSTD_decompressDCtx, libzstd), Csize_t,
            (Ptr{ZSTD_DCtx}, Ref{UInt8}, Csize_t, Ref{UInt8}, Csize_t,),
            dctx, dst, length(dst), src, length(src),
        )
        if ZSTD_isError(ret)
            err_code = ZSTD_getErrorCode(ret)
            if err_code == Integer(ZSTD_error_dstSize_tooSmall)
                return NOT_SIZE
            elseif err_code == Integer(ZSTD_error_memory_allocation)
                throw(OutOfMemoryError())
            else
                throw(ZstdDecodingError(ret))
            end
        else
            @assert ret ∈ 0:length(dst)
            return Int64(ret)
        end
    finally
        # free ZSTD_DCtx
        ccall((:ZSTD_freeDCtx, libzstd), Csize_t, (Ptr{ZSTD_DCtx},), dctx)
    end
end

# For now rely on fallback `try_resize_decode!`
# Incase `try_find_decoded_size` returns `nothing`, the fallback repeatedly 
# calls `try_decode!` with larger and larger `dst`.
# This isn't ideal, but in a chunk decoding context
# the decoded size is typically found by `try_find_decoded_size`.

using Random: Random
using ChunkCodecCore: encode_bound, decoded_size_range, encode, decode
using ChunkCodecLibZstd:
    ChunkCodecLibZstd,
    ZstdCodec,
    ZstdEncodeOptions,
    ZstdDecodeOptions,
    ZstdDecodingError,
    ZSTD_minCLevel,
    ZSTD_maxCLevel,
    ZSTD_defaultCLevel,
    ZSTD_versionNumber,
    ZSTD_isError,
    ZSTD_bounds,
    ZSTD_cParam_getBounds,
    ZSTD_dParam_getBounds
using ChunkCodecTests: test_codec
using Test: @testset, @test_throws, @test
using Aqua: Aqua

Aqua.test_all(ChunkCodecLibZstd; persistent_tasks = false)

Random.seed!(1234)

@testset "library info functions" begin
    ZSTD_c_compressionLevel = Int32(100)
    bounds = ZSTD_cParam_getBounds(ZSTD_c_compressionLevel)
    @test !ZSTD_isError(bounds.error)
    @test bounds.lowerBound == ZSTD_minCLevel()
    @test bounds.upperBound == ZSTD_maxCLevel()
    @test ZSTD_defaultCLevel() ∈ ZSTD_minCLevel():ZSTD_maxCLevel()
    @test ZSTD_versionNumber().major == 1
    ZSTD_d_windowLogMax = Int32(100)
    bounds = ZSTD_dParam_getBounds(ZSTD_d_windowLogMax)
    @test bounds isa ZSTD_bounds
end
@testset "encode_bound" begin
    local a = last(decoded_size_range(ZstdEncodeOptions()))
    @test encode_bound(ZstdEncodeOptions(), a) == typemax(Int64) - 1
    # zstd has adds a margin to encode bound for sizes less than 128 KB
    # Ensure this doesn't break monotonicity
    for i in 1:(Int64(128)<<10 + 100)
        @test encode_bound(ZstdEncodeOptions(), i) ≥ encode_bound(ZstdEncodeOptions(), i-1)
    end
end
@testset "default" begin
    test_codec(ZstdCodec(), ZstdEncodeOptions(), ZstdDecodeOptions(); trials=100)
end
@testset "compressionLevel options" begin
    # Compression level is clamped
    for i in [typemin(Int128); -30:25;]
        test_codec(ZstdCodec(), ZstdEncodeOptions(; compressionLevel=i), ZstdDecodeOptions(); trials=3)
    end
end
@testset "other options" begin
    # checksum
    test_codec(ZstdCodec(), ZstdEncodeOptions(; checksum=true), ZstdDecodeOptions(); trials=50)
    test_codec(ZstdCodec(), ZstdEncodeOptions(; checksum=false), ZstdDecodeOptions(); trials=50)
    # advanced parameters
    # As an example turn off the content size flag
    # From zstd.h:
    ZSTD_c_contentSizeFlag = Int32(200)
    # /* Content size will be written into frame header _whenever known_ (default:1)
    # * Content size must be known at the beginning of compression.
    # * This is automatically the case when using ZSTD_compress2(),
    # * For streaming scenarios, content size must be provided with ZSTD_CCtx_setPledgedSrcSize() */
    e = ZstdEncodeOptions(;advanced_parameters=[
        ZSTD_c_contentSizeFlag=>Int32(0),
    ])
    test_codec(ZstdCodec(), e, ZstdDecodeOptions(); trials=50)
end
@testset "unexpected eof" begin
    e = ZstdEncodeOptions()
    d = ZstdDecodeOptions()
    u = [0x00, 0x01, 0x02]
    c = encode(e, u)
    @test decode(d, c) == u
    for i in 1:length(c)
        @test_throws ZstdDecodingError decode(d, c[1:i-1])
    end
    @test_throws ZstdDecodingError decode(d, u)
    c[2] = 0x00
    @test_throws ZstdDecodingError decode(d, c)
    @test_throws ZstdDecodingError decode(d, [encode(e, u); c])
    @test_throws ZstdDecodingError decode(d, [encode(e, u); 0x00])
    e = ZstdEncodeOptions(;checksum=true)
    c = encode(e, u)
    c[end] = 0x00
    # This fails checksum
    @test_throws ZstdDecodingError decode(d, c)
end
@testset "errors" begin
    @test sprint(Base.showerror, ZstdDecodingError(:foo)) ==
        "ZstdDecodingError: foo"
    @test startswith(
        sprint(Base.showerror, ZstdDecodingError(-1%Csize_t)),
        "ZstdDecodingError: ",
    )
end
@testset "public" begin
    if VERSION >= v"1.11.0-DEV.469"
        for sym in (
            :ZSTD_minCLevel,
            :ZSTD_maxCLevel,
            :ZSTD_defaultCLevel,
            :ZSTD_versionNumber,
            :ZSTD_isError,
            :ZSTD_bounds,
            :ZSTD_cParam_getBounds,
            :ZSTD_dParam_getBounds
        )
            @test Base.ispublic(ChunkCodecLibZstd, sym)
        end
    end
end
